714 - Copying Books——[贪心、二分查找]

Before the invention of book-printing, it was very hard to make a copy of a book. All the contents had
to be re-written by hand by so called scribers. The scriber had been given a book and after several
months he finished its copy. One of the most famous scribers lived in the 15th century and his name
was Xaverius Endricus Remius Ontius Xendrianus (Xerox). Anyway, the work was very annoying and
boring. And the only way to speed it up was to hire more scribers.
Once upon a time, there was a theater ensemble that wanted to play famous Antique Tragedies. The
scripts of these plays were divided into many books and actors needed more copies of them, of course.
So they hired many scribers to make copies of these books. Imagine you have m books (numbered
1, 2, . . . , m) that may have different number of pages (p1, p2, . . . , pm) and you want to make one copy of
each of them. Your task is to divide these books among k scribes, k ≤ m. Each book can be assigned
to a single scriber only, and every scriber must get a continuous sequence of books. That means, there
exists an increasing succession of numbers 0 = b0 < b1 < b2, . . . < bk−1 ≤ bk = m such that i-th scriber
gets a sequence of books with numbers between bi−1 + 1 and bi
. The time needed to make a copy of
all the books is determined by the scriber who was assigned the most work. Therefore, our goal is to
minimize the maximum number of pages assigned to a single scriber. Your task is to find the optimal
assignment.
Input
The input consists of N cases. The first line of the input contains only positive integer N. Then follow
the cases. Each case consists of exactly two lines. At the first line, there are two integers m and k,
1 ≤ k ≤ m ≤ 500. At the second line, there are integers p1, p2, . . . , pm separated by spaces. All these
values are positive and less than 10000000.
Output
For each case, print exactly one line. The line must contain the input succession p1, p2, . . . pm divided
into exactly k parts such that the maximum sum of a single part should be as small as possible. Use
the slash character (‘/’) to separate the parts. There must be exactly one space character between any
two successive numbers and between the number and the slash.
If there is more than one solution, print the one that minimizes the work assigned to the first scriber,
then to the second scriber etc. But each scriber must be assigned at least one book.
Sample Input
2
9 3
100 200 300 400 500 600 700 800 900
5 4
100 100 100 100 100
Sample Output
100 200 300 400 500 / 600 700 / 800 900
100 / 100 / 100 / 100 100

解题思路:
  本题的优化目标是使最大连续子序列的和最小,并且在最大子序列和相同的情况下s1、s2...尽量小。那么我们可以从右边开始,尽量向左划分,当目前剩余书本数等于剩余的人数时,剩余每本书的分配策略只能是每人一本。

代码如下:

 1 #include <iostream>
 2 #include <cstring>
 3 #include <vector>
 4 #include <cstdio>
 5 #include <algorithm>
 6 using namespace std;
 7 #define maxm 500+5
 8 typedef long long LL;
 9 int m,k;
10 int p[maxm];
11 vector<int> s;
12 int ans[maxm];
13 LL M;
14
15 bool judge(LL x){
16
17     s.clear();
18     bool flag=true;
19     int cnt=k;
20     for(int i = m;i>0;){
21         LL sum = 0;
22         while(i > 0 && sum + p[i] <= x){
23             if(i + 1 == cnt) break;
24             sum += p[i--];
25         }
26         s.push_back(i);
27         cnt--;
28         if(s.size()>k){
29             flag = false;
30             break;
31         }
32     }
33     if(flag){
34         int j=0;
35         for(int i = s.size() - 1;i >= 0;i--){
36             ans[j++] = s[i];
37         }
38         return true;
39     }
40     else return false;
41 }
42 int main(int argc, const char * argv[]) {
43     freopen("/Users/hujiacheng/Desktop/input.txt", "r", stdin);
44     int N;
45     scanf("%d",&N);
46     while(N--){
47         M=0;
48         memset(ans, 0, sizeof ans);
49         scanf("%d%d",&m,&k);
50         for(int i=1;i<=m;i++){
51             scanf("%d",&p[i]);
52             M += p[i];
53         }
54         LL l=1,r=M;
55         LL mid=(l+r)/2;
56         while(l<r){
57             if(judge(mid)){
58                 r=mid;
59                 mid=(l+r)/2;
60
61             }
62             else {
63                 l=mid+1;
64                 mid=(l+r)/2;
65             }
66         }
67         int j=1;
68         for(int i=1;i<=m;i++){
69             if(i!=1) cout<<" ";
70             cout<<p[i];
71             if(i==ans[j]){
72                 cout<<" /";
73                 j++;
74             }
75         }
76         cout<<endl;
77     }
78     return 0;
79 }
时间: 2024-10-19 17:20:41

714 - Copying Books——[贪心、二分查找]的相关文章

uva 714 - Copying Books(贪心 最大值最小化 二分)

题目描述开头一大堆屁话,我还仔细看了半天..其实就最后2句管用.意思就是给出n本书然后要分成k份,每份总页数的最大值要最小.问你分配方案,如果最小值相同情况下有多种分配方案,输出前面份数小的,就像字典序输出从小到大一样的意思. 这里用到贪心的方法,定义f(x)为真的条件是满足x为最大值使n本书分成k份,那么就是求x的最小值.如何确定这个x就是用的二分法,x一定大于0小于所有值的合,不断的二分再判断是否成立,成立就取左半边,不成立说明太小了就取右半边,写的时候还是没有把二分法理解透彻,我还怕会丢失

UVA 714 Copying Books 抄书 (二分)

题意:把一个包含m个正整数的序列划分成k个非空的连续子序列.使得所有连续子序列的序列和Si的最大值尽量小. 二分,每次判断一下当前的值是否满足条件,然后修改区间.注意初始区间的范围,L应该为所有正整数中的最大值,否则应该判断时注意.输出解的时候要使字典序最小,所以从后面贪心. #include<bits/stdc++.h> using namespace std; typedef long long ll; const int maxm = 501; ll p[maxm]; bool vis[

UVa 714 - Copying Books 二分答案

题目链接:714 - Copying Books 解题思路 具体处理方法见代码 /************************************************************** Problem: User: youmi Language: C++ Result: Accepted Time: Memory: ****************************************************************/ //#pragma comm

uva 714 Copying Books (二分)

uva 714 Copying Books Before the invention of book-printing, it was very hard to make a copy of a book. All the contents had to be re-written by hand by so called scribers. The scriber had been given a book and after several months he finished its co

贪心/二分查找 BestCoder Round #43 1002 pog loves szh II

题目传送门 1 /* 2 贪心/二分查找:首先对ai%=p,然后sort,这样的话就有序能使用二分查找.贪心的思想是每次找到一个aj使得和为p-1(如果有的话) 3 当然有可能两个数和超过p,那么an的值最优,每次还要和an比较 4 注意:不能选取两个相同的数 5 反思:比赛时想到了%p和sort,lower_bound,但是还是没有想到这个贪心方法保证得出最大值,还是题目做的少啊:( 6 */ 7 #include <cstdio> 8 #include <algorithm>

hdu 1969 Pie(贪心+二分查找)(简单)

Pie Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 5628    Accepted Submission(s): 2184 Problem Description My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I

UVa 714 Copying Books(贪心 二分)

题意  把m数分成k组  使每组数的和的最大值最小  如果有多种分法 靠前的组的和尽量小 关键是找出那个最小的最大值   可以通过二分来找出  开始左端点为m个数中最大的数  右端点为m个数的和  若中点能将m个数分为小于等于k组  比它大的肯定都是可以的  中点变为右端点   否则中点变成左端点 然后就可以贪心逆向模拟了  从后往前每组选择尽量多的数直到剩下的数等于组数 #include <bits/stdc++.h> using namespace std; typedef long lo

UVa 714 Copying books 贪心+二分 最大值最小化

题目大意: 要抄N本书,编号为1,2,3...N, 每本书有1<=x<=10000000页, 把这些书分配给K个抄写员,要求分配给某个抄写员的那些书的编号必须是连续的.每个抄写员的速度是相同的,求所有书抄完所用的最少时间的分配方案. 题目中的要求是去求划分的子序列的最大值尽量小,最大值最小化,如果从划分的角度看,无法获得好的思路,我们可以从值得角度考虑,所要求的最小的最大值必定是从[amax,sum(总和)]中取得的,那么我们可以二分法的方式猜测一个数字,看它是否满足要求,如果满足要求,我们可

Can you find it?——[二分查找]

Description Give you three sequences of numbers A, B, C, then we give you a number X. Now you need to calculate if you can find the three numbers Ai, Bj, Ck, which satisfy the formula Ai+Bj+Ck = X. Input There are many cases. Every data case is descr